阅读 18

异常处理-C#

Exception.jpg

​ 异常处理是指程序在运行过程中,发生错误会导致程序退出,这种错误,就叫做异常。

因此处理这种错误,就称为异常处理。

异常处理机制

​ 在C#中的异常处理机制是使用使用try, catch,finally代码块进行处理。

  1. try块

    在try块中包含会抛出异常的代码;而且一个try快必须关联catch或者finally。

  2. catch块

    在catch中包含处理异常的代码;一个try块可以关联多个catch块,catch后面的参数为捕捉类型,而他的捕捉类型必须是System.Exception或者它的派生类,如果有多个catch块,那么其中的捕捉类型必须是由子类由上至下的排列,一次捕捉;当然为了兼容其他CLR的语言(CLR允许抛出任何类型,不仅仅是Exception类及子类 ,比如Int32,DateTime,String),所以catch后面也可以不许用加捕捉类型

    void Method(){
        try{
            ....
        }
        catch(XxxException){//捕捉XxxException异常
            ...
        }
        catch(YyyException){//捕捉YyyException异常
            ...
        }
        catch(Excetion){//捕捉Exception异常
            ...
        }
        catch{//捕捉所有抛出的试列
            ...
        }
    }
    复制代码
  3. finally块

    在finally块中包含必须执行的代码。一般finally块中执行try块中需要清理资源的操作,必须在打开了文件后,关闭文件就应放在finally块中:

    void Method(string pathName){
        FileStream fs = null;
        try{
            fs = new FileStream(pathName,FileMode.Open);
            ...
        }
        catch(IOException){
            ...
        }
        finally{
            //确保fs被清理
            if(fs!=null) fs.Close();
        }
    }
    复制代码

    以上的代码就确保了是否try包含异常,文件都会被关闭。如果没有finally,那么文件关闭操作只会在垃圾回收中执行。

System.Exception类

​ CLR允许抛出任何类型的实例。但是C#必须抛出System.Exception类及他的子类。

System.Exception类型常公共属性

属性名称 访问 类型 说明
Message 只读 String 错误消息以处理异常的开发人员为目标。Message属性的文本应该完整地描述错误,并且在可能的情况下,还应该解释如何更正错误。顶级异常处理程序可以向最终用户显示消息,因此您应该确保它在语法上是正确的,并且消息的每个句子都以句点结束。不要使用问号或感叹号。如果您的应用程序使用本地化的异常消息,则应确保准确转换它们
Data 只读 IDictionary 使用Data属性返回的System.Collections.IDictionary对象来存储和检索与异常相关的补充信息。代码在抛出异常前在该集合中添加记录项;捕捉异常的代码可在异常恢复过程中查询记录项并利用其中信息。
Source 读/写 String 包含生成异常的程序集名称。
StackTrace 只读 String 包含抛出异常前的堆栈信息。其中的信息是描述了异常发生前调用的哪些方法,这些信息用于检查代码,修复bug非常有效
InnerException 只读 Exception 如果当前异常是在处理一个异常时抛出的,指出上一个异常是什么
TargetSite 只读 MethodBase 包含抛出异常的方法。

一个异常抛出时,CLR会记录throw指令的位置,然后在访问StackTrace属性时将堆栈信息写入。

每次当throw ex时,会重置异常的起点。

void Method(){
    try{
        ....
    }
    catch(Exception ex){
        throw ex;//ex的StackTrace中的起点就更新为这里
    }
}
复制代码
        public static void MethodDemo1()
        {
            string exstr1 = "", exstr2="", exstr3="";
            try
            {
                try
                {
                    try
                    {
                        throw new Exception("这是一个异常");
                    }
                    catch(Exception ex)
                    {
                        exstr1 = ex.StackTrace;
                        //   at LearningDemo.ExceptionDemo.MethodDemo1() in C:\Users\wuxia\Desktop\桌面临时文件\LearningDemo\LearningDemo\ExceptionDemo.cs:line 19
                        throw;
                    }
                }
                catch(Exception ex)
                {
                    exstr2 = ex.StackTrace;
                    //   at LearningDemo.ExceptionDemo.MethodDemo1() in C:\Users\wuxia\Desktop\桌面临时文件\LearningDemo\LearningDemo\ExceptionDemo.cs:line 19
                    throw ex;
                }
            }
            catch(Exception ex)
            {
                exstr3 = ex.StackTrace;
                //at LearningDemo.ExceptionDemo.MethodDemo1() in C:\Users\wuxia\Desktop\桌面临时文件\LearningDemo\LearningDemo\ExceptionDemo.cs:line 30
            }
            finally
            {
                Console.WriteLine(exstr1);
                Console.WriteLine(exstr2);
                Console.WriteLine(exstr3);
            }
        }
复制代码

在以上例子: exstr3中 是通过throw ex 抛出异常, 得到的ex.StackTrace则定位到throw ex的位置.

关注下面的标签,发现更多相似文章
评论